#include <malloc.h>
#include <windows.h>
#include <conio.h>
#include <intrin.h>
#include "..\scrypt\scrypt.h"

static BYTE key_status[256];
static DWORD main_thread_id;
static HANDLE hConsole;
static CONSOLE_SCREEN_BUFFER_INFO console_info;
static CONSOLE_CURSOR_INFO cursor;
static DWORD cursor_size;
static TCHAR *password, *out_pass;
static DWORD *msg_buf;
static HANDLE sema;
static int i_new_msg;
static BOOL show_pass = FALSE, use_alternate = FALSE;


int rand_gen(unsigned char *buf, int size, int prf)
{
	HCRYPTPROV hProv;
	unsigned char *pool1, *pool2;
	int half_size = size / 2;
	POINT curs_pos;

	AttachConsole(ATTACH_PARENT_PROCESS);
	pool1 = _aligned_malloc(2 * size + 16 + 4, 16);
	pool2 = pool1 + size + 16;

	if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, 0) && !CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_NEWKEYSET)) {
		_cprintf("CryptAcquireContext() failed.\n");
		return 1;
	}

	if (!CryptGenRandom(hProv, size, pool1)) {
		_cprintf("CryptGenRandom() failed.\n");
		return 1;
	}
	((__int64*)pool1)[0] += _rdtsc();
	if (scrypt(prf, pool1, half_size, pool1 + half_size, half_size, 32768, 16, 1, pool2, size))
		return 1;
	if (!CryptGenRandom(hProv, size, pool2)) {
		_cprintf("CryptGenRandom() failed.\n");
		return 1;
	}
	CryptReleaseContext(hProv, 0);
	((__int64*)pool2)[0] += _rdtsc();
	GetCursorPos(&curs_pos);
	((DWORD*)pool2)[2] += curs_pos.x;
	((DWORD*)pool2)[3] += curs_pos.y;
	if (scrypt(prf, pool2, half_size, pool2 + half_size, half_size, 32768, 16, 1, pool1, size))
		return 1;

	memcpy(buf, pool1, size);
	SecureZeroMemory(pool1, 2 * size + 16 + 4);
	_aligned_free(pool1);

	return 0;
}


static LRESULT __stdcall LowLevelKeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			key_status[((KBDLLHOOKSTRUCT*)lParam)->vkCode] |= 0x80;
			switch (((KBDLLHOOKSTRUCT*)lParam)->vkCode) {
				case VK_LSHIFT: case VK_RSHIFT:
					key_status[VK_SHIFT] |= 0x80;
					break;
				case VK_LCONTROL: case VK_RCONTROL:
					key_status[VK_CONTROL] |= 0x80;
					break;
				case VK_LMENU: case VK_RMENU:
					key_status[VK_MENU] |= 0x80;
					break;
				case VK_CAPITAL: case VK_NUMLOCK: case VK_SCROLL:
					key_status[((KBDLLHOOKSTRUCT*)lParam)->vkCode] ^= 0x01;
			}
			msg_buf[i_new_msg++] = ((KBDLLHOOKSTRUCT*)lParam)->vkCode;
			msg_buf[i_new_msg++] = ((KBDLLHOOKSTRUCT*)lParam)->scanCode;
			i_new_msg &= 511;
			ReleaseSemaphore(sema, 1, NULL);
			break;

		case WM_KEYUP:
		case WM_SYSKEYUP:
			key_status[((KBDLLHOOKSTRUCT*)lParam)->vkCode] &= 0x7f;
			switch (((KBDLLHOOKSTRUCT*)lParam)->vkCode) {
				case VK_LSHIFT: case VK_RSHIFT:
					key_status[VK_SHIFT] &= 0x7f;
					break;
				case VK_LCONTROL: case VK_RCONTROL:
					key_status[VK_CONTROL] &= 0x7f;
					break;
				case VK_LMENU: case VK_RMENU:
					key_status[VK_MENU] &= 0x7f;
			}
	}

	switch (((KBDLLHOOKSTRUCT*)lParam)->vkCode) {
		case VK_CAPITAL: case VK_NUMLOCK: case VK_SCROLL:
			return CallNextHookEx(NULL, code, wParam, lParam);
		default:
			return TRUE;
	}
}

static void disp_pass(int i)
{
	CONSOLE_SCREEN_BUFFER_INFO curs_pos;
	DWORD c_written;
	TCHAR c_tmp;
	int j;

	for (j = 0; password[j]; j++) out_pass[j] = show_pass ? password[j] : '*';
	out_pass[j++] = ' ';
	out_pass[j++] = ' ';
	out_pass[j] = 0;

	WriteConsoleOutputCharacter(hConsole, out_pass, j, console_info.dwCursorPosition, &c_written);
	if (c_written < j) {
		SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
		_cwprintf(L"%s", out_pass);
		console_info.dwCursorPosition.Y--;
	}

	c_tmp = out_pass[i];
	out_pass[i] = 0;
	SetConsoleCursorPosition(hConsole, console_info.dwCursorPosition);
	_cwprintf(L"%s", out_pass);
	out_pass[i] = c_tmp;
	SetConsoleCursorInfo(hConsole, &cursor);
	// prevent cursor disappearance with left and right keys
	GetConsoleScreenBufferInfo(hConsole, &curs_pos);
	SetConsoleCursorPosition(hConsole, curs_pos.dwCursorPosition);
}

static DWORD __stdcall pass_thread(LPVOID lpParam)
{
	TCHAR ch[64];
	BOOL insert = TRUE;
	DWORD keycode, scancode, c_written;
	int i, j, n, new_char, i_msg;

	GetConsoleScreenBufferInfo(hConsole, &console_info);
	i_msg = i = n = 0;
	do {
		WaitForSingleObject(sema, INFINITE);
		keycode = msg_buf[i_msg++];
		scancode = msg_buf[i_msg++];
		i_msg &= 511;
		switch (keycode) {
			case VK_RETURN: case VK_ESCAPE:
				show_pass = TRUE;
				cursor.dwSize = cursor_size;
			case VK_TAB:
				show_pass = !show_pass;
				FillConsoleOutputCharacter(hConsole, ' ', -1, console_info.dwCursorPosition, &c_written);
				break;
			case VK_BACK:
				if (i) {
					for (j = i; j < n; j++) password[j - 1] = password[j];
					password[--n] = 0;
					i--;
				}
				break;
			case VK_LEFT:
				if (i) i--;
				break;
			case VK_RIGHT:
				if (i < n) i++;
				break;
			case VK_INSERT:
				cursor.dwSize = (insert = !insert) ? cursor_size : 100;
				break;
			case VK_DELETE:
				for (j = i; j < n; j++) password[j] = password[j + 1];
				if (i < n) n--;
				break;
			case VK_HOME:
				i = 0;
				break;
			case VK_END:
				i = n;
				break;
			default:
				new_char = ToUnicode(keycode, scancode, key_status, ch, _countof(ch), 0);
				if (new_char < 1 || n >= 250) break;
				new_char = min(new_char, 250 - n);
				if (insert) {
					for (j = n - 1; j >= i; j--) password[j + new_char] = password[j];
					n += new_char;
				} else if (i + new_char > n) n = i + new_char;
				for (j = 0; j < new_char; j++) password[i + j] = ch[j];
				i += new_char;
		}
		disp_pass(i);
	} while (keycode != VK_RETURN && keycode != VK_ESCAPE);

	_cwprintf(L"%s", out_pass + i);
	PostThreadMessage(main_thread_id, WM_APP, keycode, 0);

	return 0;
}

int password_edit(TCHAR *pass_buf) {
	HHOOK hook;
	MSG msg;
	HKEY reg_key;
	BOOL insert = TRUE;
	TCHAR c, prev_c = 0, c_overwritten = 0;
	DWORD prev_time = 0;
	DWORD n, c_written;
	int i, j;

	password = pass_buf;
	out_pass = pass_buf + 512;
	msg_buf = (DWORD*)(pass_buf + 1024);
	ZeroMemory(pass_buf, 256 * sizeof(TCHAR));
	hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleCursorInfo(hConsole, &cursor);
	if (RegOpenKeyEx(HKEY_CURRENT_USER, L"Console", 0, KEY_QUERY_VALUE, &reg_key) == ERROR_SUCCESS) {
		n = sizeof cursor.dwSize;
		RegQueryValueEx(reg_key, L"CursorSize", NULL, NULL, (void*)&cursor.dwSize, &n);
		RegCloseKey(reg_key);
		SetConsoleCursorInfo(hConsole, &cursor);
	}
	cursor_size = cursor.dwSize;

	if (!use_alternate) {
		i_new_msg = 0;
		main_thread_id = GetCurrentThreadId();
		GetKeyboardState(key_status);
		for (i = 0; i < 256; i++) key_status[i] &= 0x7f;
		if (!(sema = CreateSemaphore(NULL, 0, 2048 / 8 - 1, NULL)))
			_cprintf("CreateSemaphore() failed.\n");
		else if (!(hook = SetWindowsHookEx(WH_KEYBOARD_LL, LowLevelKeyboardProc, GetModuleHandle(NULL), 0)))
			_cprintf("SetWindowsHookEx() failed.\n");
		else {
			CreateThread(NULL, 0, pass_thread, NULL, 0, NULL);
			GetMessage(&msg, NULL, 0, 0);
			UnhookWindowsHookEx(hook);
			CloseHandle(sema);
			if (msg.wParam == VK_ESCAPE) {
				_putch('\n');
				return TRUE;
			}
			if (password[0]) {
				_putch('\n');
				return FALSE;
			}
		}
		_cprintf("\rAlternate input method activated.\n");
		use_alternate = TRUE;
	}

	GetConsoleScreenBufferInfo(hConsole, &console_info);
	i = n = 0;
	do {
		c = _getwch();
		if (c == '\r' || c == 27) {
			show_pass = FALSE;
			FillConsoleOutputCharacter(hConsole, ' ', -1, console_info.dwCursorPosition, &c_written);
			cursor.dwSize = cursor_size;
		}
		else if (!c) {
			_getwch();
			continue;
		}
		else if (c == '\t') {
			show_pass = !show_pass;
			FillConsoleOutputCharacter(hConsole, ' ', -1, console_info.dwCursorPosition, &c_written);
		}
		else if (c == '\b') {
			if (i) {
				for (j = i; j < n; j++) password[j - 1] = password[j];
				password[--n] = 0;
				i--;
			}
		}
		else if (prev_c == 224 && c != 224 && GetTickCount() - prev_time < 100) {
			if (n < 250) {
				if (insert) {
					for (j = --i; j < n; j++) password[j] = password[j + 1];
					n--;
				} else {
					if (!c_overwritten) n--;
					password[--i] = c_overwritten;
				}
			}
			switch (c) {
				case 75: // backward
					if (i) i--;
					break;
				case 77: // forward
					if (i < n) i++;
					break;
				case 82: // insert
					cursor.dwSize = (insert = !insert) ? cursor_size : 100;
					break;
				case 83: // delete
					for (j = i; j < n; j++) password[j] = password[j + 1];
					if (i < n) n--;
					break;
				case 71: // home
					i = 0;
					break;
				case 79: // end
					i = n;
			}
		} else if (n < 250) {
			if (insert) {
				for (j = n; j > i; j--) password[j] = password[j - 1];
				n++;
			} else {
				c_overwritten = password[i];
				if (i == n) n++;
			}
			password[i++] = c;
		}
		disp_pass(i);
		prev_c = c;
		prev_time = GetTickCount();
	} while (c != '\r' && c != 27);

	_cwprintf(L"%s\n", out_pass + i);

	return c == 27;
}
