#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "twofish.h"

char *convert_to_string(int len, unsigned char *val, char *str)
{
	int i;
	char *strptr = str;

	for (i = 0; i < len / 8; i++) {
		sprintf(strptr, "%02X", val[i]);
		strptr += 2;
	}
	return str;
}

unsigned char k1[] = {0xD4, 0x3B, 0xB7, 0x55, 0x6E, 0xA3, 0x2E, 0x46, 0xF2, 0xA2, 0x82, 0xB7, 0xD4, 0x5B, 0x4E, 0x0D, 0x57, 0xFF, 0x73, 0x9D, 0x4D, 0xC9, 0x2C, 0x1B, 0xD7, 0xFC, 0x01, 0x70, 0x0C, 0xC8, 0x21, 0x6F};
unsigned char pt1[] = {0x90, 0xAF, 0xE9, 0x1B, 0xB2, 0x88, 0x54, 0x4F, 0x2C, 0x32, 0xDC, 0x23, 0x9B, 0x26, 0x35, 0xE6};
unsigned char k2[] = {0x24, 0x8A, 0x7F, 0x35, 0x28, 0xB1, 0x68, 0xAC, 0xFD, 0xD1, 0x38, 0x6E, 0x3F, 0x51, 0xE3, 0x0C, 0x2E, 0x21, 0x58, 0xBC, 0x3E, 0x5F, 0xC7, 0x14, 0xC1, 0xEE, 0xEC, 0xA0, 0xEA, 0x69, 0x6D, 0x48};
unsigned char pt2[] = {0x43, 0x10, 0x58, 0xF4, 0xDB, 0xC7, 0xF7, 0x34, 0xDA, 0x4F, 0x02, 0xF0, 0x4C, 0xC4, 0xF4, 0x59};

int main(int argc, char *argv[])
{
	twofish_key key;
	unsigned char buffer[16];
	char tmpstr[80];
	int i;

	for (i = 0; i < 8; i++)
		key.key[i] = 0;
	for (i = 0; i < 16; i++)
		buffer[i] = 0;
	twofish_init(&key);
	printf("-test 1-\n");
	printf("Plaintext          = %s\n", convert_to_string(128, buffer, tmpstr));
	printf("Key                = %s\n", convert_to_string(256, (unsigned char*)key.key, tmpstr));
	twofish_encrypt(&key, buffer);
	printf("Ciphertext         = %s\nExpected           = 57FF739D4DC92C1BD7FC01700CC8216F\n", convert_to_string(128, buffer, tmpstr));
	twofish_decrypt(&key, buffer);
	printf("Decrypted-plaintext= %s\n", convert_to_string(128, buffer, tmpstr));

	memcpy(key.key, k1, sizeof k1);
	memcpy(buffer, pt1, sizeof pt1);
	twofish_init(&key);
	printf("-test 2-\n");
	printf("Plaintext          = %s\n", convert_to_string(128, buffer, tmpstr));
	printf("Key                = %s\n", convert_to_string(256, (unsigned char*)key.key, tmpstr));
	twofish_encrypt(&key, buffer);
	printf("Ciphertext         = %s\nExpected           = 6CB4561C40BF0A9705931CB6D408E7FA\n", convert_to_string(128, buffer, tmpstr));
	twofish_decrypt(&key, buffer);
	printf("Decrypted-plaintext= %s\n", convert_to_string(128, buffer, tmpstr));

	memcpy(key.key, k2, sizeof k2);
	memcpy(buffer, pt2, sizeof pt2);
	twofish_init(&key);
	printf("-test 3-\n");
	printf("Plaintext          = %s\n", convert_to_string(128, buffer, tmpstr));
	printf("Key                = %s\n", convert_to_string(256, (unsigned char*)key.key, tmpstr));
	twofish_encrypt(&key, buffer);
	printf("Ciphertext         = %s\nExpected           = 37FE26FF1CF66175F5DDF4C33B97A205\n", convert_to_string(128, buffer, tmpstr));
	twofish_decrypt(&key, buffer);
	printf("Decrypted-plaintext= %s\n", convert_to_string(128, buffer, tmpstr));

	twofish_close(&key);

	return 0;
}
